## puredata 0.54.0+ds

=== libpd/Makefile ===
# This is a makefile to build libpd from vanilla Pd sources.  It assumes that
# the Pd source directory "../src" is parallel to this directory in order to
# find the Pd sources.

UNAME = $(shell uname)
SOLIB_PREFIX = lib
STATICLIB_EXT = a
LIBPD_IMPLIB =
LIBPD_DEF =
PLATFORM_ARCH ?= $(shell $(CC) -dumpmachine | sed -e 's,-.*,,')

ifeq ($(UNAME), Darwin)  # Mac
  SOLIB_EXT = dylib
  PLATFORM_CFLAGS = -DHAVE_LIBDL
  PLATFORM_LDFLAGS = -dynamiclib -ldl -Wl,-no_compact_unwind
  ifeq ($(FAT_LIB), true)
    # macOS universal "fat" lib compilation
    MAC_VER = $(shell sw_vers -productVersion | cut -f1 -f2 -d.)
    ifeq ($(shell expr $(MAC_VER) \<= 10.13), 1)
      # universal1: macOS 10.6 - 10.13
      FAT_ARCHS ?= -arch i386 -arch x86_64
    endif
    ifeq ($(shell expr $(MAC_VER) \>= 11.0), 1)
      # universal2: macOS 11.0+
      FAT_ARCHS ?= -arch arm64 -arch x86_64
    endif
    FAT_ARCHS ?= -arch $(PLATFORM_ARCH)
    PLATFORM_CFLAGS += $(FAT_ARCHS)
    PLATFORM_LDFLAGS += $(FAT_ARCHS)
  endif
else
  ifeq ($(OS), Windows_NT)  # Windows, use Mingw
    CC ?= gcc
    SOLIB_EXT = dll
    SOLIB_PREFIX =
    LIBPD_IMPLIB = libpd.lib
    LIBPD_DEF = libpd.def
    PLATFORM_CFLAGS = -DWINVER=0x502 -DWIN32 -D_WIN32 -DPD_INTERNAL
    MINGW_LDFLAGS = -shared -Wl,--export-all-symbols -lws2_32 -lkernel32 \
                    -static-libgcc
    PLATFORM_LDFLAGS = $(MINGW_LDFLAGS) -Wl,--output-def=$(LIBPD_DEF) \
                       -Wl,--out-implib=$(LIBPD_IMPLIB)
  else  # Linux or *BSD
    SOLIB_EXT = so
    PLATFORM_CFLAGS = -Wno-int-to-pointer-cast -Wno-pointer-to-int-cast -fPIC
    PLATFORM_LDFLAGS = -shared -Wl,-Bsymbolic
    ifeq ($(UNAME), Linux)
      PLATFORM_CFLAGS += -DHAVE_LIBDL
      PLATFORM_LDFLAGS += -ldl
    endif
  endif
endif

VPATH = ../src:\
../extra/bob~:../extra/bonk~:../extra/choice:../extra/fiddle~:../extra/loop~:\
../extra/lrshift~:../extra/pd~:../extra/pique:../extra/sigmund~:../extra/stdout

# The C flags are separated into CPPFLAGS, CODECFLAGS, and MORECFLAGS
# to allow easy overriding of CODECFLAGS and to allow adding MORECFLAGS:

# C preprocessor flags, and flags controlling errors and warnings
CPPFLAGS = -I../src -DPD -DHAVE_UNISTD_H -DUSEAPI_DUMMY -DLIBPD_EXTRA \
    -DPDINSTANCE -DPD_INTERNAL

# code generation flags (e.g., optimization).
CODECFLAGS = -fPIC -ffast-math -funroll-loops -fomit-frame-pointer -O3

# anything else you want to specify.
MORECFLAGS =

# additional linker flags to override to add more (like "-g").
MORELDFLAGS =

CFLAGS = $(CPPFLAGS) $(PLATFORM_CFLAGS) $(CODECFLAGS) $(MORECFLAGS)
LDFLAGS = $(PLATFORM_LDFLAGS) $(MORELDFLAGS)

PDSRC = g_canvas.c g_graph.c g_text.c g_rtext.c g_array.c g_template.c g_io.c \
    g_scalar.c g_traversal.c g_guiconnect.c g_readwrite.c g_editor.c g_clone.c \
    g_all_guis.c g_bang.c g_mycanvas.c g_numbox.c g_radio.c g_slider.c \
    g_toggle.c g_undo.c g_vumeter.c g_editor_extras.c \
    m_pd.c m_class.c m_obj.c m_atom.c m_memory.c m_binbuf.c \
    m_conf.c m_glob.c m_sched.c \
    s_main.c s_inter.c s_inter_gui.c s_print.c \
    s_loader.c s_path.c s_entry.c s_audio.c s_midi.c s_net.c s_utf8.c \
    s_audio_paring.c \
    d_ugen.c d_ctl.c d_arithmetic.c d_osc.c d_filter.c d_dac.c d_misc.c \
    d_math.c d_fft.c d_fft_fftsg.c d_array.c d_global.c \
    d_delay.c d_resample.c d_soundfile.c d_soundfile_aiff.c d_soundfile_caf.c \
    d_soundfile_next.c d_soundfile_wave.c \
    x_arithmetic.c x_connective.c x_interface.c x_midi.c x_misc.c \
    x_time.c x_acoustics.c x_net.c x_text.c x_gui.c x_list.c x_array.c \
    x_file.c x_scalar.c  x_vexp.c x_vexp_if.c x_vexp_fun.c \

SRC = $(PDSRC) \
    x_libpdreceive.o s_audio_dummy.o s_midi_dummy.o \
    z_hooks.o z_libpd.o z_print_util.o z_queued.o z_ringbuffer.o \
    bob~.o bonk~.o choice.o fiddle~.o loop~.o lrshift~.o pique.o sigmund~.o \
    pd~.o stdout.o

OBJ = $(SRC:.c=.o)

LIBPD = $(SOLIB_PREFIX)pd.$(SOLIB_EXT)
LIBPD_STATIC = libpd.$(STATICLIB_EXT)

.PHONY: libpd clean

libpd: $(LIBPD) $(LIBPD_STATIC)

$(LIBPD): $(OBJ)
	$(CC) -o $@ $^ -shared -lm -lpthread $(LDFLAGS)

$(LIBPD_STATIC): $(OBJ)
	ar rcs $@ $^

clean:
	-rm -f *.o $(LIBPD) $(LIBPD_STATIC) $(LIBPD_IMPLIB) $(LIBPD_DEF)

=== debian/changelog ===
puredata (0.54.0+ds-4) unstable; urgency=medium

  * Have puredata64-core provide the "pd64" virtual package

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 19 Jul 2023 12:54:36 +0200

puredata (0.54.0+ds-3) unstable; urgency=medium

  * Properly calculate the deken CPU for loading Pd64 externals
    (Closes: #1040517)
    + Install a re-usable helper-tool to determine the correct CPU value in
      external-extensions in the puredata-dev package
  * Add some Pd64 autopkgtests

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 10 Jul 2023 15:52:13 +0200

puredata (0.54.0+ds-2) unstable; urgency=medium

  * Explicitly set external-extension and deken-cpu for Pd64
  * Run autopkgtest verbosely

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 05 Jul 2023 21:11:42 +0200

puredata (0.54.0+ds-1) unstable; urgency=medium

  * First upload of both single-precision and double-precision Pd
    to unstable!

  * Add patch to fix crash with multichannel [adc~]

  * puredata-common
    + Improve description of puredata-common
    + Relax hard dependency on puredata-common to a simple Recommends
    + Properly declare Breaks/Relation dependency for moving files from
      puredata-core to puredata-common
    + Mark as "Multi-Arch: foreign"
  * libpd0/libpd-dev
    + Add patch to fix missing symbol in libpd
    + Install libpd example
    + Add autopkgtest for libpd
  * puredata-utils
    + Mark as "Multi-Arch: foreign"
  * Add/update lintian-overrides to package split and puredata64
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 05 Jul 2023 12:50:00 +0200

puredata (0.54.0+ds-1~exp1) experimental; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * New upstream version 0.54.0+ds
    + Refresh pd2puredata patch
    + Refresh more patches
    + Drop patches applied upstream
  * Build two flavours of Pd
    - single precision (puredata)
    - double precision (puredata64)
  * Build libpd0 and libpd-dev
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints

  [ Debian Janitor ]
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 03 Jul 2023 23:08:18 +0200

puredata (0.53.1+ds-2+exp1) experimental; urgency=medium

  * Upload multiple flavours to experimental

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 29 Jan 2023 00:11:25 +0100

puredata (0.53.1+ds-2~exp1) experimental; urgency=medium

  * Upload multiple flavours to experimental

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 28 Jan 2023 22:06:11 +0100

puredata (0.53.1+ds-1+exp1) experimental; urgency=medium

  * Upload multiple flavours to experimental
  * Refresh patches

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 13 Dec 2022 09:53:43 +0100

puredata (0.52.2+ds0-2+exp1) experimental; urgency=medium

  * Upload multiple-flavours to experimental
  * Refresh patches

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 19 Sep 2022 15:02:27 +0200

puredata (0.52.1+ds0-2~exp1) experimental; urgency=medium

  * Build (and package) multiple flavours of Pd
    - single precision application
    - double precision application (puredata64)
    - single precision library (libpd)
  * Add patch to limit visibility of libpd symbols

  * d/rules:
    - Make build more verbose

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 08 Feb 2022 11:37:42 +0100

=== debian/control ===
Source: puredata
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Paul Brossier <piem@debian.org>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 gettext,
 libasound2-dev [linux-any],
 libjack-dev,
 portaudio19-dev,
Build-Depends-Indep:
 python3:any,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://puredata.info
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/puredata.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/puredata

Package: puredata
Architecture: all
Depends:
 puredata-common(<< ${source:Upstream-Version}+1~),
 puredata-common(>= ${source:Version}),
 puredata-core  (<< ${source:Upstream-Version}+1~),
 puredata-core  (>= ${source:Version}),
 puredata-dev   (<< ${source:Upstream-Version}+1~),
 puredata-dev   (>= ${source:Version}),
 puredata-doc   (<< ${source:Upstream-Version}+1~),
 puredata-doc   (>= ${source:Version}),
 puredata-extra (<< ${source:Upstream-Version}+1~),
 puredata-extra (>= ${source:Version}),
 puredata-gui   (<< ${source:Upstream-Version}+1~),
 puredata-gui   (>= ${source:Version}),
 puredata-utils,
 ${misc:Depends},
Suggests:
 gem,
 multimedia-puredata,
 pd-aubio,
 pd-csound,
 pd-pdp,
 pd-zexy,
Description: realtime computer music and graphics system
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing. Pd's audio functions are built-in;
 graphical computations require separate packages such as gem (Graphics
 Environment for Multimedia) or pd-pdp (Pd Packet).
 .
 This is a metapackage that depends on all components of the core of Pd.

Package: puredata-core
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 puredata-common,
 puredata-gui,
Provides:
 pd,
Breaks:
 puredata-gui (<< ${source:Upstream-Version}),
 puredata-gui (>> ${source:Upstream-Version}+1~),
Description: realtime computer music and graphics system - core components
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package only provides the core infrastructure of Pure Data.
 Most likely you will want to install "puredata-gui" (or even the full
 "puredata") as well.

Package: puredata64
Architecture: all
Depends:
 puredata-common(<< ${source:Upstream-Version}+1~),
 puredata-common(>= ${source:Version}),
 puredata-dev   (<< ${source:Upstream-Version}+1~),
 puredata-dev   (>= ${source:Version}),
 puredata-doc   (<< ${source:Upstream-Version}+1~),
 puredata-doc   (>= ${source:Version}),
 puredata-extra (<< ${source:Upstream-Version}+1~),
 puredata-extra (>= ${source:Version}),
 puredata-gui   (<< ${source:Upstream-Version}+1~),
 puredata-gui   (>= ${source:Version}),
 puredata-utils,
 puredata64-core(<< ${source:Upstream-Version}+1~),
 puredata64-core(>= ${source:Version}),
 ${misc:Depends},
Description: realtime computer music and graphics system (double precision)
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing. Pd's audio functions are built-in;
 graphical computations require separate packages such as gem (Graphics
 Environment for Multimedia) or pd-pdp (Pd Packet).
 .
 This is a metapackage that depends on all core components of double
 precision Pd.

Package: puredata64-core
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 puredata-common,
 puredata-gui,
Provides:
 pd64,
Breaks:
 puredata-gui (<< ${source:Upstream-Version}),
 puredata-gui (>> ${source:Upstream-Version}+1~),
Description: realtime computer music and graphics system - core components (double)
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package only provides the core infrastructure for the double
 precision version of Pure Data.
 Most likely you will want to install "puredata-gui" (or even the full
 "puredata64") as well.

Package: puredata-common
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 puredata-core (<< 0.54),
 puredata64-core (<< 0.54),
Replaces:
 puredata-core (<< 0.54),
 puredata64-core (<< 0.54),
Description: realtime computer music and graphics system - common components
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package only provides common parts of the core infrastructure for
 Pure Data, like the pd-watchdog (for realtime operations) and the reference
 patches.
 It is of little use without the puredata*-core package.
 Most likely you will want to install "puredata" (or "puredata64")
 instead.

Package: puredata-gui
Architecture: all
Multi-Arch: foreign
Depends:
 python3:any,
 tcl,
 tk,
 ${misc:Depends},
Recommends:
 puredata | puredata64,
 puredata-gui-l10n,
 sensible-utils,
Breaks:
 puredata-core (<< ${source:Upstream-Version}),
 puredata-core (>> ${source:Upstream-Version}+1~),
Description: realtime computer music and graphics system - GUI
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides the graphical user-interface for Pure Data.
 Most likely you will want to install "puredata-core" (or even "puredata")
 as well.
 Installing this package without the accompanying puredata-core is only useful
 if you want to run the GUI and the DSP on different machines.

Package: puredata-gui-l10n
Architecture: all
Multi-Arch: foreign
Section: localization
Depends:
 puredata-gui (= ${source:Version}),
 ${misc:Depends},
Description: realtime computer music and graphics system - translations
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides the translations for the graphical user-interface of
 Pure Data.

Package: puredata-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Recommends:
 node-html5shiv,
 puredata | puredata64,
Description: realtime computer music and graphics system - documentation
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides the documentation for Pure Data.
 Most likely you will want to install "puredata" as well.

Package: puredata-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: realtime computer music and graphics system - development files
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides the header-files for compiling externals (plugins) for
 puredata.

Package: puredata-utils
Section: utils
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 pd-utils,
Description: realtime computer music and graphics system - utility programs
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides utility applications for puredata, namely pdsend and
 pdreceive, for sending and receiving FUDI over the net.

Package: puredata-extra
Architecture: any
Depends:
 puredata-core (<< ${source:Upstream-Version}+1~) | puredata64-core (<< ${source:Upstream-Version}+1~),
 puredata-core (>= ${source:Version}) | puredata64-core (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: realtime computer music and graphics system - extra files
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides extra objects that come with Pd, e.g. for signal
 analysis (fiddle~, sigmund~, bonk~) and more.
 .
 The objects for expression evaluation (expr~) have been included into
 puredata-core, so they are no longer part of this package.

Package: libpd0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Pure Data as an embeddable audio synthesis library
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides the library version of Pd, that allows you to embed
 the audio the Pure Data computer music system into your own applications.

Package: libpd-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libpd0 (<< ${source:Version}+1~),
 libpd0 (>= ${source:Version}),
 puredata-dev   (<< ${source:Version}+1~),
 puredata-dev   (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Pure Data as an embeddable audio synthesis library - header files
 Pure Data (also known as Pd) is a real-time graphical programming environment
 for audio and graphics processing.
 .
 This package provides development files needed to build programs that link
 against the embedable library version of Pd.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
DH_VERBOSE=1

## use hardening some flags
DPKG_EXPORT_BUILDFLAGS = 1
# if you change values below, you might also need to fix d/salsa-ci.yml
DEB_BUILD_MAINT_OPTIONS=hardening=+format,-fortify,+stackprotector,+relro
export DEB_BUILD_MAINT_OPTIONS

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

FLAVORS=pd32 pd64
builddir=debian/build/flavor-

deken_cpu = $(shell debian/dekencpu ${DEB_HOST_ARCH})

export DEB_CPPFLAGS_MAINT_APPEND=

CONFIG :=
CONFIG_pd32 :=
CONFIG_pd64 :=

ifeq ($(DEB_HOST_ARCH_OS),linux)
  CONFIG += --enable-alsa
else
  CONFIG += --disable-alsa
endif
CONFIG += --enable-jack
CONFIG += --without-local-portaudio --without-local-portmidi
CONFIG += --libdir=/usr/lib/

CONFIG_pd32 += --program-transform-name='s/pd$$/puredata/'
CONFIG_pd32 += --enable-libpd --enable-libpd-utils
CONFIG_pd64 += --program-transform-name='s/pd$$/puredata64/' --with-floatsize=64 --with-deken-cpu=$(deken_cpu) --with-external-extension=linux-$(deken_cpu)-64.so

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  DEB_CPPFLAGS_MAINT_APPEND+=-D__BSD_VISIBLE
endif

## set timestamp for reproducible builds
DATE_FMT = %Y/%m/%d at %H:%M:%S UTC
ifdef SOURCE_DATE_EPOCH
    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
else
    BUILD_DATE ?= $(shell date "+$(DATE_FMT)")
endif
export BUILD_DATE
export DEB_VERSION

%:
	dh $@

execute_before_dh_autoreconf:
	mkdir -p m4/generated

override_dh_auto_configure: $(patsubst %,configure_%,$(FLAVORS))
configure_%:
	dh_auto_configure --builddir $(builddir)$* -- $(strip $(CONFIG) $(CONFIG_$*))

override_dh_auto_build-arch: $(patsubst %,build_%,$(FLAVORS))
build_%:
	dh_auto_build -a --builddir $(builddir)$*

execute_after_dh_auto_build-indep: debian/gui-plugins/pd-gui-plugin.1

override_dh_auto_install: $(patsubst %,install_%,$(FLAVORS))
install_%:
	dh_auto_install --builddir $(builddir)$*

override_dh_install:
	find debian/tmp -type f -name "pd.pc" -exec \
		sed -e 's|^Libs: .*|Libs:|' -e 's| -fPIC||' -i {} +
	dh_install -X "*.la" -X "LICENSE.txt" -X "Makefile.am"
	rm -rf debian/puredata-doc/usr/share/puredata/doc/1.manual/1.introduction.txt
	rm -rf debian/puredata-doc/usr/share/puredata/doc/5.reference
	rm -rf debian/puredata-doc/usr/share/puredata/doc/7.stuff

override_dh_installchangelogs:
	dh_installchangelogs src/CHANGELOG.txt

execute_after_dh_fixperms:
ifneq (,$(findstring puredata-extra, $(shell dh_listpackages)))
	find debian/puredata*extra/ -type f -name "*.pd_linux" -exec \
		chmod 0644 {} +
endif
ifneq (,$(findstring puredata-gui, $(shell dh_listpackages)))
	find debian/puredata-gui/ -type f -name "pkg_mkIndex.tcl" -exec \
		chmod 0755 {} +
endif

override_dh_compress:
	dh_compress -X.pd -X.wav -X.aiff -X.txt

debian/gui-plugins/pd-gui-plugin.1: debian/gui-plugins/pd-gui-plugin
	-help2man -N -n "enable or disable a Pd GUI plugin" -o $@ $<

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|.*\.wav|.*\.aiff|.*\.png|.*\.jpg|.*\.ico|.*\.icns|.*\.gif|.*\.ttf|.*\.strings|.*\.zip|.*\.tgz
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## puredata 0.54.1%2Bds

=== libpd/test_libpd/Makefile ===
# This is a makefile to build "test_libpd".  It assumes that libpd is in the 
# source directory "../" and that libpd is already built.

# detect platform
UNAME = $(shell uname)
SOLIB_PREFIX = lib

ifeq ($(UNAME), Darwin) # Mac
  SOLIB_EXT = dylib
  STATICLIB_EXT = a
  PLATFORM = mac
else
  ifeq ($(OS), Windows_NT) # Windows, use Mingw
    SOLIB_PREFIX =
    SOLIB_EXT = dll
    STATICLIB_EXT = lib
    PLATFORM = windows
  else # assume Linux
    SOLIB_EXT = so
    STATICLIB_EXT = a
    PLATFORM = linux
  endif
endif

PD_DIR = ../..
LIBPD_DIR = ..
LIBPD = $(LIBPD_DIR)/$(SOLIB_PREFIX)pd.$(SOLIB_EXT)
LIBPD_STATIC = $(LIBPD_DIR)/libpd.$(STATICLIB_EXT)

SRC_FILES = test_libpd.c
TARGET = test_libpd

CFLAGS = -I$(PD_DIR)/src -O3

.PHONY: libs clean-libs clean clobber

all: $(TARGET)

##### libs

$(LIBPD):
	cp $(LIBPD_DIR)/$(LIBPD) .

# on windows, copy libpd and MinGW winpthread dll to here
ifeq ($(PLATFORM), windows)

LDFLAGS = $(LIBPD)

PTHREAD_DIR = ${MINGW_PREFIX}/bin
PTHREAD = libwinpthread-1.dll

$(PTHREAD):
	cp $(PTHREAD_DIR)/$(PTHREAD) .

libs: $(LIBPD) $(PTHREAD)

clean-libs:
	rm -f $(LIBPD) $(PTHREAD)

# mac & linux
else

# force static linking? make STATIC=true
ifeq ($(STATIC), true)
LDFLAGS = $(LIBPD_STATIC)
else # copy libpd to here by default
LDFLAGS = $(LIBPD)
libs: $(LIBPD)
endif

clean-libs:
	rm -f $(LIBPD)

endif

##### target

$(TARGET): ${SRC_FILES:.c=.o} libs
	$(CC) -o $@ ${SRC_FILES:.c=.o} $(LDFLAGS)

##### clean

clean: clean-libs
	rm -f $(TARGET) *.o

=== debian/tests/control ===
Test-Command: pd -nogui -send "pd quit"
Restrictions: allow-stderr
Depends:
 puredata-core,

Test-Command: pd64 -nogui -send "pd quit"
Restrictions: allow-stderr
Depends:
 puredata64-core,

Test-Command: debian/tests/runtest choice-test
Depends:
 puredata-core,
 puredata-extra,

Test-Command: PD=pd64 debian/tests/runtest choice-test
Depends:
 puredata-extra,
 puredata64-core,

Test-Command: debian/tests/runtest zexy.repeat-test
Depends:
 pd-zexy,
 puredata-core,

Test-Command: make -C libpd/test_libpd/ && (cd libpd/test_libpd/; ./test_libpd )
Depends:
 build-essential,
 libpd-dev,

## puredata 0.54.1+ds

=== debian/changelog ===
puredata (0.54.1+ds-4build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:21:28 +0000

puredata (0.54.1+ds-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:03:38 +0000

puredata (0.54.1+ds-4build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:00:38 +0000

puredata (0.54.1+ds-4) unstable; urgency=medium

  * Update patches
    + Backport patch to fix out-of-bound memory access
    + Backport patch to unqueue iemgui's on free
    + Backport patch to fix deken CPU-specifier on arm64
    + Sort debian/upstream patches into subdirectories
    + Apply debian-specific patches after other patches
    + Add 'Applied-Upstream' field to patches
    + Refresh patches with 'gbp pq'
  * Update d/*.symbols

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 05 Feb 2024 22:24:38 +0100

puredata (0.54.1+ds-3) unstable; urgency=medium

  * Fix filename for maintainer script (Closes: #1057685)
  * Only update alternatives in certain stages of postinst script
    (configure|abort-upgrade|abort-deconfigure|abort-remove)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 29 Dec 2023 19:30:40 +0100

puredata (0.54.1+ds-2) unstable; urgency=medium

  * Use wildcards for lintian-overrides with per-arch filenames
  * Add "Forwarded: not-needed" to Debian-specific patches
  * Add patch to explicitly export required symbols
  * Add initial libpd0.symbols

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 12 Dec 2023 21:48:10 +0100

puredata (0.54.1+ds-1) unstable; urgency=medium

  * New upstream version 0.54.1+ds
    (Closes: #1050695)
    + Refresh pd2puredata patch
    + Drop patches applied upstream
    + Refresh patches
  * Restore po/ directory after build (Closes: #1047924)
  * Update copyright information
    + Bump copyright dates
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 31 Oct 2023 15:19:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: puredata
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Paul Brossier <piem@debian.org>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,

## puredata 0.55.0+ds

=== debian/changelog ===
puredata (0.55.0+ds-1) unstable; urgency=medium

  * New upstream version 0.55.0+ds
    + Drop patches applied upstream
    + Refresh patches
  * Add patch to restore old "pd quit" behaviour with exitcodes
  * Add patch to properly export symbols
  * Do not install d_osc.h
  * Relax dependency of puredata-gui-l10n to an unversioned puredata-gui
  * Update libpd0 symbols
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 11 Jun 2024 22:25:35 +0200

puredata (0.54.1+ds-5) unstable; urgency=medium

  * Team upload
  * debian/control: Make libpd-dev binNMU-safe

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 08 May 2024 21:55:18 +0200

## puredata 0.55.1+ds

=== debian/changelog ===
puredata (0.55.1+ds-2) unstable; urgency=medium

  * Backport fix for crasher-bug in [fexpr~]
  * Mark debian/provicy.patch as not-for-upstream
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 14 Sep 2024 22:44:30 +0200

puredata (0.55.1+ds-1) unstable; urgency=medium

  * New upstream version 0.55.1+ds
    + Drop patches applied upstream
    + Refresh patches
    + Update patches
  * Update pd2puredata.patch updater
  * Update changed upstream path to "about Pd"
  * Update lintian-overrides (upstream filename change)
  * libpd: Update symbols-file
  * Update copyright information
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 09 Sep 2024 23:00:57 +0200

## puredata 0.55.2+ds

=== libpd/Makefile ===
# This is a makefile to build libpd from vanilla Pd sources.  It assumes that
# the Pd source directory "../src" is parallel to this directory in order to
# find the Pd sources.

UNAME = $(shell uname)
SOLIB_PREFIX = lib
STATICLIB_EXT = a
LIBPD_IMPLIB =
LIBPD_DEF =
PLATFORM_ARCH ?= $(shell $(CC) -dumpmachine | sed -e 's,-.*,,')

ifeq ($(UNAME), Darwin)  # Mac
  SOLIB_EXT = dylib
  PLATFORM_CFLAGS = -DHAVE_ALLOCA_H -DHAVE_LIBDL -DHAVE_MACHINE_ENDIAN_H
  PLATFORM_LDFLAGS = -dynamiclib -ldl -Wl,-no_compact_unwind
  # helps for machine/endian.h to be found
  PLATFORM_CFLAGS += -D_DARWIN_C_SOURCE
  # increase max allowed file descriptors
  PLATFORM_CFLAGS += -D_DARWIN_UNLIMITED_SELECT -DFD_SETSIZE=10240
  ifeq ($(FAT_LIB), true)
    # macOS universal "fat" lib compilation
    MAC_VER = $(shell sw_vers -productVersion | cut -f1 -f2 -d.)
    ifeq ($(shell expr $(MAC_VER) \<= 10.13), 1)
      # universal1: macOS 10.6 - 10.13
      FAT_ARCHS ?= -arch i386 -arch x86_64
    endif
    ifeq ($(shell expr $(MAC_VER) \>= 11.0), 1)
      # universal2: macOS 11.0+
      FAT_ARCHS ?= -arch arm64 -arch x86_64
    endif
    FAT_ARCHS ?= -arch $(PLATFORM_ARCH)
    PLATFORM_CFLAGS += $(FAT_ARCHS)
    PLATFORM_LDFLAGS += $(FAT_ARCHS)
  endif
else
  ifeq ($(OS), Windows_NT)  # Windows, use Mingw
    CC ?= gcc
    SOLIB_EXT = dll
    SOLIB_PREFIX =
    LIBPD_IMPLIB = libpd.lib
    LIBPD_DEF = libpd.def
    PLATFORM_CFLAGS = -DWINVER=0x502 -DWIN32 -D_WIN32
    MINGW_LDFLAGS = -shared -Wl,--export-all-symbols -lws2_32 -lkernel32 \
                    -static-libgcc
    PLATFORM_LDFLAGS = $(MINGW_LDFLAGS) -Wl,--output-def=$(LIBPD_DEF) \
                       -Wl,--out-implib=$(LIBPD_IMPLIB)
  else  # Linux or *BSD
    SOLIB_EXT = so
    PLATFORM_CFLAGS = -Wno-int-to-pointer-cast -Wno-pointer-to-int-cast -fPIC \
                      -DHAVE_ENDIAN_H
    PLATFORM_LDFLAGS = -shared -Wl,-Bsymbolic
    ifeq ($(UNAME), Linux)
      PLATFORM_CFLAGS += -DHAVE_ALLOCA_H -DHAVE_LIBDL
      PLATFORM_LDFLAGS += -ldl
    endif
  endif
endif

VPATH = ../src:\
../extra/bob~:../extra/bonk~:../extra/choice:../extra/fiddle~:../extra/loop~:\
../extra/lrshift~:../extra/pd~:../extra/pique:../extra/sigmund~:../extra/stdout

# The C flags are separated into CPPFLAGS, CODECFLAGS, and MORECFLAGS
# to allow easy overriding of CODECFLAGS and to allow adding MORECFLAGS:

# C preprocessor flags, and flags controlling errors and warnings
CPPFLAGS = -DPD -DUSEAPI_DUMMY -DPD_INTERNAL -DHAVE_UNISTD_H \
           -I../src -DLIBPD_EXTRA -DPDINSTANCE

# code generation flags (e.g., optimization).
CODECFLAGS = -fPIC -ffast-math -funroll-loops -fomit-frame-pointer -O3

# anything else you want to specify.
MORECFLAGS =

# additional linker flags to override to add more (like "-g").
MORELDFLAGS =

CFLAGS = $(CPPFLAGS) $(PLATFORM_CFLAGS) $(CODECFLAGS) $(MORECFLAGS)
LDFLAGS = $(PLATFORM_LDFLAGS) $(MORELDFLAGS)

PDSRC = d_arithmetic.c d_array.c d_ctl.c d_dac.c d_delay.c d_fft.c \
        d_fft_fftsg.c d_filter.c d_global.c d_math.c d_misc.c d_osc.c \
        d_resample.c d_soundfile.c d_soundfile_aiff.c d_soundfile_caf.c \
        d_soundfile_next.c d_soundfile_wave.c d_ugen.c \
        g_all_guis.c g_array.c g_bang.c g_canvas.c g_clone.c g_editor.c \
        g_editor_extras.c g_graph.c g_guiconnect.c g_io.c g_mycanvas.c \
        g_numbox.c g_radio.c g_readwrite.c g_rtext.c g_scalar.c g_slider.c \
        g_template.c g_text.c g_toggle.c g_traversal.c g_undo.c g_vumeter.c \
        m_atom.c m_binbuf.c m_class.c m_conf.c m_glob.c m_memory.c m_obj.c \
        m_pd.c m_sched.c \
        s_audio.c s_audio_dummy.c s_inter.c s_inter_gui.c s_loader.c s_main.c \
        s_net.c s_path.c  s_print.c s_utf8.c \
        x_acoustics.c x_arithmetic.c x_array.c x_connective.c x_file.c x_gui.c \
        x_interface.c x_list.c x_midi.c x_misc.c x_net.c x_scalar.c x_text.c \
        x_time.c x_vexp.c x_vexp_if.c x_vexp_fun.c

EXTRASRC = bob~.c bonk~.c choice.c fiddle~.c loop~.c lrshift~.c pique.c \
           pdsched.c pd~.c sigmund~.c stdout.c

LIBPDSRC = s_libpdmidi.c x_libpdreceive.c z_hooks.c z_libpd.c \
           z_print_util.c z_queued.c z_ringbuffer.c

SRC = $(PDSRC) $(EXTRASRC) $(LIBPDSRC)

OBJ = $(SRC:.c=.o)

LIBPD = $(SOLIB_PREFIX)pd.$(SOLIB_EXT)
LIBPD_STATIC = libpd.$(STATICLIB_EXT)

.PHONY: libpd clean

libpd: $(LIBPD) $(LIBPD_STATIC)

$(LIBPD): $(OBJ)
	$(CC) -o $@ $^ -shared -lm -lpthread $(LDFLAGS)

$(LIBPD_STATIC): $(OBJ)
	ar rcs $@ $^

clean:
	-rm -f *.o $(LIBPD) $(LIBPD_STATIC) $(LIBPD_IMPLIB) $(LIBPD_DEF)

=== debian/changelog ===
puredata (0.55.2+ds-2) unstable; urgency=medium

  * Backport patch with alternate names for some functions
    + Update libpd0.symbols for alternate names
  * Backport patch for gcc-15 compat (Closes: #1097665)
  * Refresh patches with 'gbp pq'
  * Update git repository layout to follow DEP-14
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 22 Apr 2025 11:51:27 +0200

puredata (0.55.2+ds-1) unstable; urgency=medium

  * New upstream version 0.55.2+ds
    + Refresh pd2puredata patch
    + Drop patch applied upstream
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 17 Nov 2024 17:07:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: puredata
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Paul Brossier <piem@debian.org>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
@@ -14,7 +13,7 @@
  portaudio19-dev,
 Build-Depends-Indep:
  python3:any,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://puredata.info
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/puredata.git
@@ -174,7 +173,7 @@
 Multi-Arch: foreign
 Section: localization
 Depends:
- puredata-gui (= ${source:Version}),
+ puredata-gui,
  ${misc:Depends},
 Description: realtime computer music and graphics system - translations
  Pure Data (also known as Pd) is a real-time graphical programming environment
@@ -263,8 +262,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libpd0 (<< ${source:Version}+1~),
- libpd0 (>= ${source:Version}),
+ libpd0 (= ${binary:Version}),
  puredata-dev   (<< ${source:Version}+1~),
  puredata-dev   (>= ${source:Version}),
  ${misc:Depends},

## puredata 0.56.0+ds

=== debian/changelog ===
puredata (0.56.0+ds-2) unstable; urgency=medium

  * Backport removal of exporting undefined functions (Closes: #1111508)
  * Refresh patches

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 18 Aug 2025 21:40:14 +0200

puredata (0.56.0+ds-1) unstable; urgency=medium

  * New upstream version 0.56.0+ds
    + Refresh pd2puredata patch
    + Drop obsolete patches
    + Refresh patches
  * Update symbols
    + Add new names
    + Replace "+ds-1~" suffix with "~"
  * Add patch to ensure that scalar_doclick() is not visible
  * Update copyright information
    + Exclude .dll files from source package
    + Bump copyright years
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 11 Aug 2025 19:56:56 +0200

## puredata 0.56.1+ds

=== libpd/test_libpd/Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 PD_DIR = ../..
 LIBPD_DIR = ..
-LIBPD = $(LIBPD_DIR)/$(SOLIB_PREFIX)pd.$(SOLIB_EXT)
+LIBPD = $(SOLIB_PREFIX)pd.$(SOLIB_EXT)
 LIBPD_STATIC = $(LIBPD_DIR)/libpd.$(STATICLIB_EXT)
 
 SRC_FILES = test_libpd.c
@@ -38,7 +38,9 @@
 
 ##### libs
 
+# build libpd and move a copy here
 $(LIBPD):
+	make -C $(LIBPD_DIR)
 	cp $(LIBPD_DIR)/$(LIBPD) .
 
 # on windows, copy libpd and MinGW winpthread dll to here

=== debian/changelog ===
puredata (0.56.1+ds-1) unstable; urgency=medium

  * New upstream version 0.56.1+ds
    + Refresh pd2puredata patch
    + Drop patch applied upstream
    + Refresh visibility patch

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 22 Aug 2025 23:41:52 +0200

=== debian/watch ===
# process this file with 'uscan'
version=4

#opts="uversionmangle=s/-/./;s/test/~/" \
#  http://msp.ucsd.edu/Software/pd-@ANY_VERSION@.src.tar.gz

opts=uversionmangle=s/-/./;s/test/~/;s/-really/+really/,\
     repacksuffix=+ds,\
     dversionmangle=auto \
  https://github.com/pure-data/pure-data/tags .*/v?(\d\S*)\.tar\.gz

## puredata 0.56.2%2Bds

=== libpd/Makefile ===
--- 
+++ 
@@ -76,6 +76,9 @@
 # additional linker flags to override to add more (like "-g").
 MORELDFLAGS =
 
+# additional source files you might want
+MORESRC =
+
 CFLAGS = $(CPPFLAGS) $(PLATFORM_CFLAGS) $(CODECFLAGS) $(MORECFLAGS)
 LDFLAGS = $(PLATFORM_LDFLAGS) $(MORELDFLAGS)
 
@@ -101,7 +104,7 @@
 LIBPDSRC = s_libpdmidi.c x_libpdreceive.c z_hooks.c z_libpd.c \
            z_print_util.c z_queued.c z_ringbuffer.c
 
-SRC = $(PDSRC) $(EXTRASRC) $(LIBPDSRC)
+SRC = $(PDSRC) $(EXTRASRC) $(LIBPDSRC) $(MORESRC)
 
 OBJ = $(SRC:.c=.o)

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,6 @@
 Build-Depends-Indep:
  python3:any,
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Homepage: https://puredata.info
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/puredata.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/puredata

## puredata 0.56.2+ds

=== debian/changelog ===
puredata (0.56.2+ds-1) unstable; urgency=medium

  * New upstream version 0.56.2+ds
    + Refresh pd2puredata patch

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Fix spelling mistakes in old d/changelog entries
  * Add new functions to libpd0.symbols
  * Drop obsolete Rules-Requires-Root stanza.
  * Update watchfile to version 5

  [ Alexandre Detiste ]
  * 'quilt' is the default

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 10 Nov 2025 14:39:09 +0100

=== debian/rules ===
--- 
+++ 
@@ -53,8 +53,13 @@
 %:
 	dh $@
 
+execute_before_dh_clean:
+	test ! -d po.bak || rm -rf po
+	test ! -d po.bak || mv po.bak po
+
 execute_before_dh_autoreconf:
 	mkdir -p m4/generated
+	cp -r po po.bak
 
 override_dh_auto_configure: $(patsubst %,configure_%,$(FLAVORS))
 configure_%:

=== debian/tests/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Test-Command: pd -nogui -send "pd quit"
-Restrictions: allow-stderr
+Restrictions:
+ allow-stderr,
 Depends:
  puredata-core,
 
 Test-Command: pd64 -nogui -send "pd quit"
-Restrictions: allow-stderr
+Restrictions:
+ allow-stderr,
 Depends:
  puredata64-core,

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: auto
Owner: pure-data
Project: pure-data
Repacksuffix: +ds
Uversionmangle: s/-/./;s/test/~/;s/-really/+really/
